local CQI = Cartographer_QuestInfo
local L = Rock("LibRockLocale-1.0"):GetTranslationNamespace("Cartographer_QuestInfo")

local Quixote = LibStub("LibQuixote-2.0")

-------------------------------------------------------------------

function CQI:PatchTooltip()
	if IsAddOnLoaded("beql") or IsAddOnLoaded("QuestGuru") or IsAddOnLoaded("QuestHelper") then return end
	self:AddScriptHook(GameTooltip, "OnTooltipSetItem")
	self:AddScriptHook(GameTooltip, "OnTooltipSetUnit")
end

function CQI:GetTooltipQuestName(uid)
	if self.db.profile.showQuestTag then
		return L["Quest: "]..Quixote:GetTaggedQuestName(uid)
	else
		local _, _, title = Quixote:GetQuestByUid(uid)
		return L["Quest: "]..title
	end
end

function CQI:OnTooltipSetUnit(tooltip, ...)
	if self.db.profile.showTooltip then
		local name = tooltip:GetUnit()
		if name and Quixote:IsQuestMob(name) then
			for _, uid in Quixote:IterateQuestsForMob(name) do
				local _, i, n = Quixote:GetQuestObjective(uid, name)
				if i and n then
					GameTooltip:AddDoubleLine(self:GetTooltipQuestName(uid), i..'/'..n, 1, 0.5, 0)
				end
			end
		end
	end
	return self.hooks[tooltip].OnTooltipSetUnit(tooltip, ...)
end

function CQI:OnTooltipSetItem(tooltip, ...)
	if self.db.profile.showTooltip then
		local t = tooltip:GetItem()
		if t then
			local uid, _, i, n = Quixote:IsQuestItem(t)
			if uid and i and n then
				tooltip:AddDoubleLine(self:GetTooltipQuestName(uid), i..'/'..n, 1, 0.5, 0)
			end
		end
	end
	return self.hooks[tooltip].OnTooltipSetItem(tooltip, ...)
end
